# Copyright (c) 2000-2009, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define with()          %{expand:%%{?with_%{1}:1}%%{!?with_%{1}:0}}
%define without()       %{expand:%%{?with_%{1}:0}%%{!?with_%{1}:1}}
%define bcond_with()    %{expand:%%{?_with_%{1}:%%global with_%{1} 1}}
%define bcond_without() %{expand:%%{!?_without_%{1}:%%global with_%{1} 1}}

%bcond_with javadoc
# repolib is now created only for RHEL-6 builds
%if "%{?rhel}" == "6"
%bcond_without repolib
%else
%bcond_with repolib
%endif
# Until assemply-plugin 1.4 is available for RHEL-{4,5} builds
# this cannot be built here or Version.class will not be created
%bcond_without mead

%define repodir %{_javadir}/repository.jboss.com/org/jboss/netty/%{namedversion}-brew
%define repodirlib %{repodir}/lib
%define repodirsrc %{repodir}/src

%define reltag .Final
%define namedversion %{version}%{reltag}

Name:		netty
Summary: 	Netty is a NIO client server framework which enables quick and easy development of network applications such as protocol servers and clients
Version: 	3.2.3
Release: 	5.1%{?dist}
Epoch:		0
License: 	ASL 2.0
Group: 		Development/Java
URL:		http://www.jboss.org/netty
# svn export http://anonsvn.jboss.org/repos/netty/tags/netty-3.2.3.Final
# Exported revision 2389.
# tar czf netty-3.2.3-src.tar.gz netty-3.2.3.Final
%if %without mead
Source0:	netty-3.2.3-src.tar.gz
%endif
Source1:        %{name}-jpp-depmap.xml
Source2:	%{name}-component-info.xml
#Do not use buildnumber during brew build as it tries to check and update src
#Do not package as bundle as we are not building javadoc since it R: apiviz
Patch0:         %{name}-pom.patch

BuildArch:      noarch
BuildRoot:   %{_tmppath}/%{name}-buildroot

BuildRequires:	jpackage-utils >= 0:1.7.3
%if %with mead
BuildRequires:  %{name}-mead = %{namedversion}
%else
%if %with javadoc
BuildRequires:	apiviz >= 0:1.3.1
%endif
BuildRequires:	ant >= 0:1.7.1
BuildRequires:	ant-contrib >= 0:1.0-0.b3
BuildRequires:  dtdparser
BuildRequires:	easymock-classextension2
BuildRequires:  google-guice
BuildRequires:	ivy
BuildRequires:	jboss-common-logging-spi
BuildRequires:	jboss-microcontainer2 >= 0:2.0.6
BuildRequires:	jboss-parent
BuildRequires:	jboss-xnio-base
BuildRequires:	log4j >= 0:1.2.14
BuildRequires:	protobuf-java >= 0:2.3.0
BuildRequires:	spring2-beans
BuildRequires:	xerces-j2 >= 0:2.9.1
BuildRequires:  xml-commons-jaxp-1.3-apis >= 0:1.3.04

BuildRequires:  maven2 >= 0:2.0.7-8
BuildRequires:	maven-buildmagic-thirdparty-plugin
BuildRequires:	maven2-plugin-antrun
BuildRequires:	maven2-plugin-assembly
BuildRequires:  maven2-plugin-compiler
BuildRequires:	maven2-plugin-deploy
BuildRequires:	maven2-plugin-eclipse
BuildRequires:	maven2-plugin-install
BuildRequires:	maven2-plugin-jar
#BuildRequires:	maven2-plugin-javadoc
BuildRequires:  maven2-plugin-release
BuildRequires:  maven2-plugin-resources
BuildRequires:	maven2-plugin-source
BuildRequires:	maven-doxia-sitetools
BuildRequires:	maven-surefire-maven-plugin
BuildRequires:	maven-surefire-provider-junit4
BuildRequires:	maven-shared-reporting-impl
BuildRequires:	felix-maven2
#BuildRequires:	mojo-maven2-plugin-buildnumber
#BuildRequires:	maven-jdocbook-plugin
%endif
	
%description
The Netty project is an effort to provide an asynchronous event-driven
network application framework and tools for rapid development of
maintainable high performance and high scalability protocol servers and
clients.  In other words, Netty is a NIO client server framework which
enables quick and easy development of network applications such as protocol
servers and clients. It greatly simplifies and streamlines network
programming such as TCP and UDP socket server.

%if %with javadoc
%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description javadoc
%{summary}.
%endif

%if %with repolib
%package repolib
Summary:        Artifacts to be uploaded to a repository library
Group:          Development/Libraries/Java

%description repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio.
%endif

%prep
%if %without mead
%setup -q -n %{name}-%{namedversion}
%patch0 -p1
%endif

%build
%if %without mead
export M2SETTINGS=$(pwd)/maven2-settings.xml
export MAVEN_REPO_LOCAL=$(pwd)/m2_repo/repository
%{_bindir}/mvn-jpp -e \
        -s ${M2SETTINGS} \
        -Dmaven.repo.local=${MAVEN_REPO_LOCAL} \
        -Dmaven2.jpp.depmap.file=%{SOURCE1} \
        -Dmaven.test.skip=true \
        install

%if %with javadoc
%{_bindir}/mvn-jpp -e \
        -s ${M2SETTINGS} \
        -Daggregate=true \
        -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
        -Dmaven2.jpp.depmap.file=%{SOURCE1} \
        -Dmaven.test.skip=true \
        javadoc:javadoc
%endif
%endif

%install
# jar
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}
install -d -m 755 $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}/
%if %without mead
install -p -m 644 target/%{name}-%{namedversion}.jar \
           $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}.jar
%else
install -p -m 644 %{_javadir}/jbossas-fordev/%{name}-%{namedversion}.jar \
           $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}.jar
install -p -m 644 %{_javadir}/jbossas-fordev/%{name}-%{namedversion}-sources.jar \
           $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}-sources.jar
unzip -j %{_javadir}/jbossas-fordev/org.jboss.netty-%{name}-%{namedversion}-sources.zip \
 netty-%{namedversion}/COPYRIGHT.txt \
 netty-%{namedversion}/NOTICE.txt \
 netty-%{namedversion}/LICENSE.txt 
%endif
install -p -m 644 *txt $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}/

# pom
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/maven2/poms
%if %without mead
install -m 644 pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-%{name}.pom
%else
install -p -m 644 %{_javadir}/jbossas-fordev/%{name}-%{namedversion}.pom \
           $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-%{name}.pom
%endif
%add_to_maven_depmap org.jboss.netty netty %{namedversion} JPP %{name}

(cd $RPM_BUILD_ROOT%{_javadir} && for jar in *-%{version}*; do ln -sf ${jar} ${jar/-%{version}/}; done)


%if %without mead
# javadoc
%if %with javadoc
mkdir -p %{buildroot}%{_javadocdir}/%{name}-%{version}
cp -pr target/site/apidocs/* %{buildroot}%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} %{buildroot}%{_javadocdir}/%{name}
%endif
%endif

# repolib
%if %with repolib
	tag=`echo %{version}-brew`
	sed -i "s/@VERSION@/$tag/g" %{SOURCE2}
	tag=`echo %{name}-%{version}-%{release} | sed 's|\.|_|g'`
	sed -i "s/@TAG@/$tag/g" %{SOURCE2}
        install -d -m 755 $RPM_BUILD_ROOT%{repodir}
        install -d -m 755 $RPM_BUILD_ROOT%{repodirlib}
        install -m 755 %{SOURCE2} $RPM_BUILD_ROOT%{repodir}/component-info.xml
%if %without mead
        install -d -m 755 $RPM_BUILD_ROOT%{repodirsrc}
        install -m 755 %{SOURCE0} $RPM_BUILD_ROOT%{repodirsrc}
        install -m 755 %{PATCH0} $RPM_BUILD_ROOT%{repodirsrc}
        cp -p pom.xml $RPM_BUILD_ROOT%{repodirlib}/%{name}.pom
%else
        %{__install} -p -m 644 %{_javadir}/jbossas-fordev/org.jboss.netty-netty-%{namedversion}-sources.zip %{buildroot}%{repodirsrc}
        cp -p %{_javadir}/jbossas-fordev/%{name}-%{namedversion}.pom \
          $RPM_BUILD_ROOT%{repodirlib}/%{name}.pom
%endif
        cp -p $RPM_BUILD_ROOT%{_javadir}/%{name}.jar $RPM_BUILD_ROOT%{repodirlib}
        cp -p $RPM_BUILD_ROOT%{_javadir}/%{name}-sources.jar $RPM_BUILD_ROOT%{repodirlib}
%if %without mead
        install -m 755 %{SOURCE3} $RPM_BUILD_ROOT%{repodir}/upload.sh
        pushd $RPM_BUILD_ROOT%{repodir}
        ./upload.sh $RPM_BUILD_ROOT/usr/share/java/repository.jboss.com/maven2-brew/
        popd
%endif

%endif

%clean
rm -Rf $RPM_BUILD_ROOT

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%defattr(0644,root,root,0755)
%doc %dir %{_docdir}/%{name}-%{version}
%doc %{_docdir}/%{name}-%{version}/COPYRIGHT.txt
%doc %{_docdir}/%{name}-%{version}/LICENSE.txt
%doc %{_docdir}/%{name}-%{version}/NOTICE.txt
%{_javadir}/%{name}*jar
%{_datadir}/maven2/poms/JPP-%{name}*.pom
%{_mavendepmapfragdir}/%{name}

%if %without mead
%if %with javadoc
%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{version}
%{_javadocdir}/%{name}
%endif
%endif

%if %with repolib
%files repolib
%defattr(0644,root,root,0755)
%{_javadir}/repository.jboss.com
%endif

%changelog
* Wed Jan 26 2011 Fernando Nasser <fnasser@redhat.com> - 0:3.2.3-5.1
- Rebuild due to double signing on previous build

* Wed Jan 26 2011 Fernando Nasser <fnasser@redhat.com> - 0:3.2.3-5
- Rebuild to use JARs signed in MEAD

* Wed Dec 22 2010 Fernando Nasser <fnasser@redhat.com> - 0:3.2.3-4
- Use MEAD binaries

* Fri Dec 17 2010 Fernando Nasser <fnasser@redhat.com> - 0:3.2.3-3
- Try another workaround for http://jira.codehaus.org/browse/MANTRUN-62

* Fri Dec 17 2010 Fernando Nasser <fnasser@redhat.com> - 0:3.2.3-2
- Adjust patch so that Version.java is not only a single line comment

* Fri Dec 17 2010 Fernando Nasser <fnasser@redhat.com> - 0:3.2.3-1
- Update to 3.2.3.Final

* Fri Aug 06 2010 Permaine Cheung <pcheung@redhat.com> - 0:3.2.1-1.Final
- Update to 3.2.1.Final

* Wed Jun 02 2010 Permaine Cheung <pcheung@redhat.com> - 0:3.2.0-3.Final
- Update to 3.2.0.Final
- Rediff pom patch

* Mon May 17 2010 Permaine Cheung <pcheung@redhat.com> - 0:3.2.0-2.CR1
- Update to CR1
- Rediff pom

* Tue Apr 27 2010 Permaine Cheung <pcheung@redhat.com> - 0:3.2.0-1.BETA1
- First release
